unit UPXmain;
interface

uses
 Windows,
 Messages,
 SysUtils,
 Classes,
 Graphics,
 Controls,
 Forms,
 Dialogs,
 StdCtrls,
 ShellApi;

type
 TForm1 = class( TForm )
    Memo1: TMemo;
    ButtonNochmal: TButton;
    Label1: TLabel;
  procedure FormCreate(Sender: TObject);
    procedure ButtonNochmalClick(Sender: TObject);
  { Private declarations }
 private
  procedure WMDROPFILES( var Message: TWMDROPFILES );
  message WM_DROPFILES;
  { Public declarations }
 public
   procedure compress;
end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.compress;
var
  anwendung:string;
  parameter:string;
  i:integer;
begin
  anwendung:=extractFilepath(Application.ExeName)+'upx.exe';
  for i:=0 to memo1.lines.count-1 do begin
    parameter:='--best '+memo1.lines[i];
    ShellExecute (Handle,
                NIL, //gleich PCHAR('OPEN'),
                PCHAR(anwendung),
                PCHAR(parameter),
                NIL, SW_SHOWNORMAL);

  end;
end;

procedure TForm1.FormCreate( Sender: TObject );
var
  i:integer;
begin
 {Inform the Microsoft Windows API 'DragAcceptFiles' that this Delphi
component will accept dropped files}
 DragAcceptFiles( Form1.Handle, True );
 memo1.clear;
 for i:=1 to ParamCount
 do memo1.lines.add(ParamStr(i));
 if ParamCount>0 then begin
   compress;
   Application.Terminate;
 end;
end;

procedure TForm1.WMDROPFILES( var Message: TWMDROPFILES );
var fileTotalI : longint;
var I : longint;
var uint : longint;
var buffer : array[0..255] of char;
begin
  memo1.clear;
 uint := $FFFFFFFF;
 {How many files are totally being dropped by you (you can select more
than 1 icon, e.g. on the destkop,
  by using <CTRL> or <SHIFT>)}
 fileTotalI := DragQueryFile( Message.Drop, uint, nil, 0 );
 {For first to last dropped icon, get its information (in this case
its filename).
  The first icon has number 0, the second icon number 1, the third
icon number 2, ...,
  the last icon number N - 1}
  for I := 1 to ( fileTotalI ) do begin
   {using the Microsoft Windows API 'DragQueryFile', store the
filename in a buffer}
   DragQueryFile( Message.Drop, I - 1, @buffer, sizeof( buffer ) );
   {and put this filename at the end of the memo}
   Form1.Memo1.Lines.Add( buffer );
  end;
  compress;
end;

procedure TForm1.ButtonNochmalClick(Sender: TObject);
begin
  compress;
end;

end.

